aboutsummaryrefslogtreecommitdiffhomepage
path: root/scripts
diff options
context:
space:
mode:
authorGravatar Gil <mcg@google.com>2018-03-10 14:08:20 -0800
committerGravatar GitHub <noreply@github.com>2018-03-10 14:08:20 -0800
commit24c4ea8d870788f06f3b4ef193967603ad3582b3 (patch)
tree39e615dedc2dbea03cc691dc1e5fdf3bd3bf5166 /scripts
parent0d3adb172bfdea5af23a937f3ec3aea32f739c4a (diff)
Parallelize the Travis run using build stages (#886)
Parallelize the travis run using build stages https://docs.travis-ci.com/user/build-stages/ This will run source checks first (style, lint) and then if all pass, kick off all platforms and builds in parallel.
Diffstat (limited to 'scripts')
-rwxr-xr-xscripts/if_changed.sh74
1 files changed, 74 insertions, 0 deletions
diff --git a/scripts/if_changed.sh b/scripts/if_changed.sh
new file mode 100755
index 0000000..616eebb
--- /dev/null
+++ b/scripts/if_changed.sh
@@ -0,0 +1,74 @@
+# Copyright 2018 Google
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# Within Travis, runs the given command if the current project has changes
+# worth building.
+#
+# Examines the following Travis-supplied environment variables:
+# - TRAVIS_PULL_REQUEST - the PR number or false for full build
+# - TRAVIS_COMMIT_RANGE - the range of commits under test; empty on a new
+# branch
+#
+# Also examines the following configured environment variables that should be
+# specified in an env: block
+# - PROJECT - Firebase or Firestore
+# - METHOD - xcodebuild or cmake
+
+function check_changes() {
+ if git diff --name-only "$TRAVIS_COMMIT_RANGE" | grep -Eq "$1"; then
+ run=true
+ fi
+}
+
+run=false
+
+# To force Travis to do a full run, change the "false" to "{PR number}" like
+# if [[ "$TRAVIS_PULL_REQUEST" == "904" ]]; then
+if [[ "$TRAVIS_PULL_REQUEST" == "false" ]]; then
+ # Full builds should run everything
+ run=true
+
+elif [[ -z "$TRAVIS_COMMIT_RANGE" ]]; then
+ # First builds on a branch should also run everything
+ run=true
+
+else
+ case "$PROJECT-$METHOD" in
+ Firebase-*)
+ check_changes '^(Firebase|Example)'
+ ;;
+
+ Firestore-xcodebuild)
+ check_changes '^Firestore/(core|third_party)'
+ ;;
+
+ Firestore-cmake)
+ check_changes '^Firestore'
+ ;;
+
+ *)
+ echo "Unknown project-method combo" 1>&2
+ echo " PROJECT=$PROJECT" 1>&2
+ echo " METHOD=$METHOD" 1>&2
+ exit 1
+ ;;
+ esac
+fi
+
+if [[ "$run" == true ]]; then
+ "$@"
+else
+ echo "skipped $*"
+fi
+